*** dovecot-1.1.5/src/lib-storage/index/mbox/istream-raw-mbox.c	2008-10-16 05:00:52.000000000 -0700
--- dovecot-1.1.5-ll/src/lib-storage/index/mbox/istream-raw-mbox.c	2008-10-24 20:17:19.000000000 -0700
***************
*** 513,518 ****
--- 513,528 ----
  		if (body_size != (uoff_t)-1 && body_size >= expected_body_size)
  			return body_size;
  
+ 		/* if the body_size is zero but the expected_body_size is non-zero,
+ 		   that means that the first line of the message's body is likely a
+ 		   From_-line and that the body_offset is pointing to the line
+ 		   *before* the first line of the body, i.e. the empty line
+ 		   separating the headers from the body. if that is the case, we
+ 		   adjust the body_offset here to point directly at the "From_" line
+ 		   (and readjust it a few lines down in case it wasn't there). */
+ 		if (body_size == 0)
+ 		    rstream->body_offset += rstream->crlf_ending ? 2 : 1;
+ 
  		i_stream_seek(rstream->istream.parent,
  			      rstream->body_offset + expected_body_size);
  		if (istream_raw_mbox_is_valid_from(rstream) > 0) {
***************
*** 522,527 ****
--- 532,540 ----
  			return expected_body_size;
  		}
  		/* invalid expected_body_size */
+ 
+ 		if (body_size == 0)
+ 		    rstream->body_offset -= rstream->crlf_ending ? 2 : 1;
  	}
  	if (body_size != (uoff_t)-1)
  		return body_size;
